/*
 * (C) Copyright 2000 Mulle kybernetiK
 *
 * Check out www.mulle-kybernetik.com for licensing details
 *
 * $Id$
 *
 * $Log$
 *
 */
#import <AppKit/AppKit.h>


@class NATMoveableRectView;


@interface ImageInfoController : NSWindowController
{
   id   delegate;
   
   id   topControl;
   id   bottomControl;
   id   leftControl;
   id   rightControl;
   id   heightControl;
   id   widthControl;
   id   lockButton;

   id   controlBox;
   id   displayBox;

   id   pageView;

   NATMoveableRectView  *imageView;
   NSImage              *image;
   NSRect               rectangle;
   NSSize               paperSize;
   NSRect               useablePaperRect;
   NSPrintInfo          *printInfo;
   int                  stretch;
}

- initWithImage:(NSImage *) p
        scaling:(NSImageScaling) scale;

- (id) delegate;

- (void) visoSetRectangle:(NSRect) rect;
- (void) syncControlsUsingMask:(unsigned int) mask;
- (void) syncImageView;
- (void) setDelegate:(id) sender;
- (void) setImageInfo:(NSRect) rect;
- (void) setPrintInfo:(NSPrintInfo *) p;
- (void) setScaling:(int) value;

extern NSString  *NATPrintInfoChanged;

@end
