//---------------------------------------------------------------------------------------
// created as InfoPanel.h by znek on Sat 08-Apr-2000
// $Id: MulleInfoPanel.h,v 1.3 2000/11/23 12:51:31 znek Exp $
//
//  Copyright (c) 2000 by Mulle kybernetiK. All rights reserved.
//
//  Permission to use, copy, modify and distribute this software and its documentation
//  is hereby granted, provided that both the copyright notice and this permission
//  notice appear in all copies of the software, derivative works or modified versions,
//  and any portions thereof, and that both notices appear in supporting documentation,
//  and that credit is given to Mulle kybernetiK in all documents and publicity
//  pertaining to direct or indirect use of this code or its derivatives.
//
//  THIS IS EXPERIMENTAL SOFTWARE AND IT IS KNOWN TO HAVE BUGS, SOME OF WHICH MAY HAVE
//  SERIOUS CONSEQUENCES. THE COPYRIGHT HOLDER ALLOWS FREE USE OF THIS SOFTWARE IN ITS
//  "AS IS" CONDITION. THE COPYRIGHT HOLDER DISCLAIMS ANY LIABILITY OF ANY KIND FOR ANY
//  DAMAGES WHATSOEVER RESULTING DIRECTLY OR INDIRECTLY FROM THE USE OF THIS SOFTWARE
//  OR OF ANY DERIVATIVE WORK.
//---------------------------------------------------------------------------------------

#import <AppKit/AppKit.h>

@class MulleLogoDrawer;

typedef struct
{
   float  scale;
   float  increment;
} mkZoom;


@interface MulleInfoPanel : NSObject
{
  IBOutlet NSWindow    *mainWindow;
  IBOutlet NSTextView  *textView;
  IBOutlet NSImageView *backgroundImageView;
  IBOutlet NSTextField  *headerView;
  IBOutlet NSTextField  *subHeaderView;
  IBOutlet NSTextField  *footerView;
  IBOutlet NSImageView *iconView;

  NSImage   *bgImage;
  NSImage   *shadeMask;
  NSImage   *alphaMask;

  MulleLogoDrawer   *mulleLogo;
  
  NSRect   insideRect;
  NSRect   outsideRect;

  NSTimer  *timer;

  NSImage  *panelImage;
  NSRect   panelImageRect;
  
  BOOL     useZNeKZoomer;

  mkZoom   *currentZoom;
}

- (void)activateMainWindow:(id)sender;
- (IBAction) pressWWW:(id) sender;
- (IBAction) pressEmail:(id) sender;

+ (NSString *)nibName;
- (void)updateImageView;

- (void)startAnimation;
- (void)animate:(NSTimer *)timer;
- (void)computeNewScale;
- (void)computeNewRotation;
- (void) setUseZNeKZoomer:(BOOL) flag;
- (NSImage *)panelImage;
- (void) updateViewsFromCustominfo;

@end
