#import "MulleInternetConfig.h"
#import <AppKit/AppKit.h>


@implementation MulleInternetConfig

//
// thanks to Ken Case kc@omnigroup.com for example code mixed
// with some code from http://developer.apple.com/qa/nw/nw60.html
//
+ (BOOL) launchURLViaInternetConfig:(NSString *) url
{
   return( [[NSWorkspace sharedWorkspace] openURL:[NSURL URLWithString:url]]);
}

//
// this code is pretty much verbatim from jnutting@orcsoftware.com
//
+ (BOOL) launchURLViaServices:(NSString *) url
{
   NSPasteboard   *pboard;
   NSArray        *urlPboardTypes;
   NSString       *serviceName;

   pboard = [NSPasteboard pasteboardWithName:@"URLServicePasteboard"];
   urlPboardTypes = [NSArray arrayWithObjects:NSStringPboardType, nil];
   [pboard declareTypes:urlPboardTypes
                  owner:nil];
   [pboard setString:url
             forType:NSStringPboardType];

   serviceName = [[NSUserDefaults standardUserDefaults] stringForKey:@"URLService"];
   if( ! serviceName)
      serviceName = @"OmniWeb/Open URL";
   return( NSPerformService( serviceName, pboard));
}


+ (BOOL) launchURLInBrowser:(NSString *) url
{
   return( [self launchURLViaInternetConfig:url] ||
           [self launchURLViaServices:url]);
}


+ (BOOL) performService:(NSString *) service
     defaultServiceName:(NSString *) defaultsname
               withText:(NSString *) s
{
   NSPasteboard   *pboard;
   NSString       *sname;

   pboard = [NSPasteboard pasteboardWithName:@"NSGeneralPboard"];
   [pboard declareTypes:[NSArray arrayWithObject:NSStringPboardType]
                  owner:nil];
   [pboard setString:[[s copy] autorelease]
             forType:NSStringPboardType];

   if((sname = [[NSUserDefaults standardUserDefaults] stringForKey:service]) == nil)
      sname = defaultsname;
   return( NSPerformService( sname, pboard));
}


+ (BOOL) launchEmailToAddress:(NSString *) address
                         text:(NSString *) text
{
   return( [self performService:@"MailService"
             defaultServiceName:@"MailViewer/Mail To"
                       withText:address]);
}


@end
