//---------------------------------------------------------------------------------------
// created as NSMulleLogoView.m by nat on Wed 12-Apr-2000
// $Id: MulleLogoDrawer.m,v 1.4 2000/11/23 12:51:31 znek Exp $
//
//  Copyright (c) 2000 by Mulle kybernetiK. All rights reserved.
//
//  Permission to use, copy, modify and distribute this software and its documentation
//  is hereby granted, provided that both the copyright notice and this permission
//  notice appear in all copies of the software, derivative works or modified versions,
//  and any portions thereof, and that both notices appear in supporting documentation,
//  and that credit is given to Mulle kybernetiK in all documents and publicity
//  pertaining to direct or indirect use of this code or its derivatives.
//
//  THIS IS EXPERIMENTAL SOFTWARE AND IT IS KNOWN TO HAVE BUGS, SOME OF WHICH MAY HAVE
//  SERIOUS CONSEQUENCES. THE COPYRIGHT HOLDER ALLOWS FREE USE OF THIS SOFTWARE IN ITS
//  "AS IS" CONDITION. THE COPYRIGHT HOLDER DISCLAIMS ANY LIABILITY OF ANY KIND FOR ANY
//  DAMAGES WHATSOEVER RESULTING DIRECTLY OR INDIRECTLY FROM THE USE OF THIS SOFTWARE
//  OR OF ANY DERIVATIVE WORK.
//---------------------------------------------------------------------------------------

#import "MulleLogoDrawer.h"
#import "NSImage+PDF.h"


@implementation MulleLogoDrawer

static NSSize  ratio = { 0.65, 0.65 };
static NSSize  offset = { -150.0 / 0.65, -140 / 0.65 };


//+ sharedInstance
//{
//   static id   sharedInstance;
//   
//   if( ! sharedInstance)
//      sharedInstance = [[self alloc] init];
//   return( sharedInstance);
//}


- init
{
   [super init];

   rotator   = [[[NSImage imageNamed:@"ring"] pdfImageRep] retain];
   mullerich = [[[NSImage imageNamed:@"mullerich"] pdfImageRep] retain];

   if( ! rotator || ! mullerich)
   {
      [self release];
      return( nil);
   }
   scaling.width = scaling.height = 1.0;
   
   return( self);
}


- (void) dealloc
{
   [mullerich release];
   [rotator release];
   [super dealloc];
}

//
// Step #1 draw rotated ring
// Step #2 draw mullerich
//
- (void) drawRect:(NSRect) rect
{
   NSAffineTransform   *transform;
   
   [[NSGraphicsContext currentContext] saveGraphicsState];
   
   transform = [NSAffineTransform transform];
   
   [transform translateXBy:rect.size.width / 2
                       yBy:rect.size.height / 2];
   [transform scaleXBy:scaling.width
                   yBy:scaling.height]; 

   [transform rotateByDegrees:rotation];
   [transform translateXBy:- rect.size.width / 2
                       yBy:- rect.size.height / 2];
   [transform concat];
   [rotator draw];
   
   [[NSGraphicsContext currentContext] restoreGraphicsState];
   
   //
   // position head according to ring
   // 
   transform = [NSAffineTransform transform];

   [transform translateXBy:rect.size.width / 2
                       yBy:rect.size.height / 2];
   [transform scaleXBy:scaling.width * ratio.width
                   yBy:scaling.height * ratio.height]; 
   [transform translateXBy:offset.width
                       yBy:offset.height];
   
   [transform concat];
   [mullerich draw];
}


- (void) setRotation:(float) value
{
   rotation = value;
}


- (void) incrementRotation:(float) value
{
   rotation += value;
}


- (float) rotation
{
   return( rotation);
}


- (void) setScaling:(float) value
{
   scaling.width = scaling.height = value;
}


- (void) incrementScaling:(float) value
{
   scaling.width  = scaling.width + value;
   scaling.height = scaling.height + value;
}


- (float) scaling
{
   return( scaling.width);
}


- (NSSize) size
{
   return( [rotator size]);
}

@end
