/*
 * (C) Copyright 2000 Mulle kybernetiK
 *
 * Check out www.mulle-kybernetik.com for licensing details
 *
 * $Id$
 *
 * $Log$
 *
 */
#import "NATControlBox.h"


@implementation NATControlBox


- (NSSlider *) slider
{
   return( slider);
}



- (BOOL) canSetFloatValue:(float) x
{
   return( ! formatter ||
           (x >= [[formatter minimum] doubleValue] &&
            x <= [[formatter maximum] doubleValue]));
}


- (float) floatValue
{
   return( [text floatValue]);
}


- (void) setFloatValue:(float) x
{
   if( [self canSetFloatValue:x])
   {
      [text setFloatValue:x];
      [slider setFloatValue:x];
   }
}


- (void) sliderChanged:(id) sender
{
   [text setFloatValue:[sender floatValue]];
   [delegate valueHasChanged:self];
}


- (void) increment:(id) sender
{
   [self setFloatValue:[self floatValue] + 1.0];
   [delegate valueHasChanged:self];
}


- (void) decrement:(id) sender
{
   [self setFloatValue:[self floatValue] - 1.0];
   [delegate valueHasChanged:self];
}


- (void) setFormatter:(NSFormatter *) p
{
   id  old;

   old = formatter;
   formatter = [p retain];
   [old release];
   [[text cell] setFormatter:formatter];
   if( slider)
   {
      [slider setMinValue:(float) [[formatter minimum] doubleValue]];
      [slider setMaxValue:(float) [[formatter maximum] doubleValue]];
   }
}


- (void) controlTextDidEndEditing:(NSNotification *) sender
{
   [delegate valueHasChanged:self];
}


- (id) formatter
{
   return( formatter);
}

@end
