/*
 * (C) Copyright 2000 Mulle kybernetiK
 *
 * Check out www.mulle-kybernetik.com for licensing details
 *
 * $Id$
 *
 * $Log$
 *
 */
#import "NATMoveAndSizeableRectView.h"


@implementation NATMoveAndSizeableRectView

#define SIZE           32.0
#define BORDER         2.0


- (void) dealloc
{
   [triangle release];
   [super dealloc];
}


- (void) drawRect:(NSRect) rect
{
   NSRect  corner;
   
   [super drawRect:rect];
   
   corner = [self bounds];

   [triangle release];
   triangle = nil;
   
   if( corner.size.width <= SIZE + 2 * BORDER ||
       corner.size.height <= SIZE + 2 * BORDER)
      return;
   
   [[NSColor orangeColor] set];
   
   corner.origin.x   += corner.size.width - SIZE - BORDER;
   corner.origin.y    = BORDER;
   corner.size.width  = SIZE;
   corner.size.height = SIZE;
   
   triangle = [[NSBezierPath alloc] init];
   [triangle moveToPoint:corner.origin];
   [triangle lineToPoint:NSMakePoint( corner.origin.x + SIZE, corner.origin.y + SIZE)];
   [triangle lineToPoint:NSMakePoint( corner.origin.x + SIZE, corner.origin.y)];
   [triangle closePath];
   [triangle fill];
}


- (BOOL) isResizing
{
   return( isResizing);
}


- (void) setIsResizing:(BOOL) flag
{
   isResizing = flag;
}


- (void) dragged:(NSPoint) delta
            from:(NSPoint) pos
{
   NSRect  frame;
   NSRect  bounds;
   
   if( ! [self isResizing])
   {
      [super dragged:delta
                from:pos];
      return;
   }

   bounds = [[self superview] bounds];
   frame  = [self frame];
   
   frame.size.width  -= delta.x;
   frame.size.height += delta.y;
   [delegate visoSetRectangle:frame];
}


- (void) mouseDown:(NSEvent *) event
{
    NSPoint   start;

    start  = [self convertPoint:[event locationInWindow]
                       fromView:nil];
    [self setIsResizing:(triangle && [triangle containsPoint:start])];
    [super mouseDown:event];
}


@end
