/*
 * (C) Copyright 2000 Mulle kybernetiK
 *
 * Check out www.mulle-kybernetik.com for licensing details
 *
 * $Id$
 *
 * $Log$
 *
 */
#import "NATMoveableRectView.h"
#import "NSCursor+ImagePrinter.h"


@implementation NATMoveableRectView

- (void) dealloc
{
   [delegate release];
   [super dealloc];
}


- (BOOL) draggingMode
{
   return( draggingMode);
}


- (void) setDraggingMode:(BOOL) flag
{
   draggingMode = flag;
}


- (void) setDelegate:(id) p
{
   id   old = delegate;

   delegate = [p retain];  // not so hot really
   [old release];
}


- (id) delegate
{
   return( delegate);
}


- (void) resetCursorRects
{
   NSCursor  *cursor;

   cursor = [self draggingMode] ? [NSCursor closedHandCursor] : [NSCursor openHandCursor];
   [self addCursorRect:[self bounds]
                cursor:cursor];
   [cursor setOnMouseEntered:YES];
}


- (void) dragged:(NSPoint) delta
            from:(NSPoint) pos
{
   NSRect  frame;
   NSRect  bounds;

   bounds = [[self superview] bounds];
   frame  = [self frame];
   
   frame.origin.x -= delta.x;
   frame.origin.y += delta.y;
   [delegate visoSetRectangle:frame];
}


- (void) mouseDown:(NSEvent *) event
{
    NSCursor      *cursor;
    NSPoint       start;
    NSPoint       curr;
    NSException   *exception;
    
    start  = [self convertPoint:[event locationInWindow]
                         fromView:nil];
    
    [self setDraggingMode:YES];
    cursor = [NSCursor closedHandCursor];
    [cursor push];
    exception = nil;
    
NS_DURING    
    for(;;)
    {
       curr = [self convertPoint:[event locationInWindow]
                        fromView:nil];

       if( [event type] == NSLeftMouseUp)
          break;

       if( [event type] == NSLeftMouseDragged)
       {
          if( start.x != curr.x ||
              start.y != curr.y)
          {	
             [self dragged:NSMakePoint( start.x - curr.x , start.y - curr.y)
                      from:start];
             start = [self convertPoint:[event locationInWindow]
                               fromView:nil];
          }
       }
       event = [[self window] nextEventMatchingMask:NSLeftMouseUpMask|NSLeftMouseDraggedMask];
    }
NS_HANDLER
   exception = localException;
NS_ENDHANDLER
   
   [self setDraggingMode:NO];
   [cursor pop];
   [exception raise]; // or won't if nil
}



@end
