/* NATPageViewBox.m created by nat on Sun 09-Jan-2000 */

#import "NATPageViewBox.h"


@implementation NATPageViewBox


- (void) setDrawBorder:(BOOL) flag
{
   drawBorder = flag;
}


- (unsigned int) borderSize
{
   return( drawBorder ? 1 : 0);
}


- (void) sync
{
   marginRect = [self bounds];
   
   if( haveMargins)
   {
      whiteArea = nonMarginatedArea;
      if( haveUnprintableBorders)
         marginRect = printableArea;
   }
   else
      if( haveUnprintableBorders)
         whiteArea = printableArea;
      else
         whiteArea = [self bounds];
}


- (void) setPrintableArea:(NSRect) area
{
   printableArea = area;
   haveUnprintableBorders = area.size.width > 0.0 && area.size.height > 0.0;
   [self sync];
}


- (void) setNonMarginatedArea:(NSRect) area
{
   nonMarginatedArea = area;
   haveMargins = area.size.width > 0.0 && area.size.height > 0.0;
   [self sync];
}


- (void) setPaperSize:(NSSize) size
{
   paperSize = size;
   [self setBoundsSize:size];  // HEY HEY!!
   [self sync];
}


- (id) initWithFrame:(NSRect) frame
{
   [super initWithFrame:frame];

   [self setPaperSize:frame.size];

   return( self);
}



//
// Draw useable paper in white
// margins in light gray
// unprintable in dark gray
// optionally draw a border arount it
// first implementation LAMEO!!

// ---- unprintable ---- | ----- margin ----- | ---- paper ....

- (void) drawRect:(NSRect) rect
{
   if( haveUnprintableBorders)
   {
      [[NSColor grayColor] set];
      NSRectFill( [self bounds]);
   }

   if( haveMargins)
   {
      [[NSColor lightGrayColor] set];
      NSRectFill( marginRect);
   }

   [[NSColor whiteColor] set];
   NSRectFill( whiteArea);
 
   if( drawBorder)
   {
      [[NSColor blackColor] set];
      NSFrameRect( [self bounds]);  // lame
   }   
}



@end
