/*
 * (C) Copyright 2000 Mulle kybernetiK
 *
 * Check out www.mulle-kybernetik.com for licensing details
 *
 * $Id$
 *
 * $Log$
 *
 */
#import "NATRectView.h"

//
// Just a yellow square with a red border
//
@implementation NATRectView

- (void) dealloc
{
   [image_ release];
   [super dealloc];
}


- (void) setImage:(NSImage *) image;
{
   image_ = [image retain];
}


- (void) setImageScaling:(int) stretch
{
   stretch_ = stretch;
}


- (BOOL) isOpaque
{
   return( YES);
}


#define BORDER 2.0

- (void) drawRect:(NSRect) rect
{
   NSRect    bounds;
   NSRect    innerBounds;
   NSRect    area;
   NSRect    imageArea;
   NSPoint   scale;
   NSSize    size;
   
#warning (nat) my naive use of NSFrameRect did not look good
   bounds = [self bounds];
   area   = NSIntersectionRect( bounds, rect);
   [[NSColor blackColor] set];
   NSRectFill( area);

   innerBounds.origin.x    = bounds.origin.x + BORDER;
   innerBounds.origin.y    = bounds.origin.y + BORDER;
   innerBounds.size.width  = bounds.size.width  - (BORDER + BORDER);
   innerBounds.size.height = bounds.size.height - (BORDER + BORDER);
   
   area = NSIntersectionRect( innerBounds, rect);
   if( ! image_)
   {
      [[NSColor yellowColor] set];
      NSRectFill( area);
      return;
   }
   
   // this can probably be done more nicely with a transform
   [[NSColor grayColor] set];
   NSRectFill( area);
   
#warning (nat) should simulate current size mode   
   imageArea.origin = NSZeroPoint;
   imageArea.size   = [image_ size];
   [image_ drawInRect:area 
             fromRect:imageArea
            operation:NSCompositeSourceOver 
             fraction:1.0];
}


//
// Frame and bounds size always identical
//
- (NSRect) bounds
{
   NSRect  rect;

   rect.origin = NSZeroPoint;
   rect.size   = [self frame].size;
   return( rect);
}

@end
