/*
 * (C) Copyright 2000 Mulle kybernetiK
 *
 * Check out www.mulle-kybernetik.com for licensing details
 *
 * $Id$
 *
 * $Log$
 *
 */
#import "NSCursor+ImagePrinter.h"


//
//
// Code loosely (ahem) based on Micha Maiers stuff
// mmmmmicha!
//
@implementation NSCursor ( ImagePrinter)


//
// Just load an image from our Resources, and create an
// NSCursor from it. Contrary to the usual convention, we
// do not return it autoreleased (as indicated in the
// method name).
// Consider this to be a "private" message
//
+ (NSCursor *) _retainedCursorWithImageNamed:(NSString *) s
{
   NSImage   *image;

   image = [NSImage imageNamed:s] ;
   if( ! image)
   {
      NSLog( @"%@.tiff image missing from app", s);
      return( nil);
   }
   return( [[NSCursor alloc] initWithImage:image
                                   hotSpot:NSMakePoint( 7, 7 )]);
}


//
// Singleton for "OpenHandCursor"
//
+ (NSCursor *) openHandCursor
{
   static NSCursor   *cursor;
   
   if( ! cursor)
      cursor = [self _retainedCursorWithImageNamed:@"OpenHandCursor"];
   return( cursor);
}


+ (NSCursor *) closedHandCursor
{
   static NSCursor   *cursor;
   
   if( ! cursor)
      cursor = [self _retainedCursorWithImageNamed:@"ClosedHandCursor"];
   return( cursor);
}




@end
